/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumDICOMSNOMEDMap;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_NonLesionModifiers;
//import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_NuclearCardiologyProtocols;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_NonLesionModifiers;


/**
 * This class represents NonLesionModifiers - CID6139
 */
public class NonLesionModifiers_CID6139 
{
	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	/**
	 * Instantiates a new NonLesionModifiers_CID6139 Template 
	 */
	public NonLesionModifiers_CID6139()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}

	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumNonLesionModifiers Object of EnumCM_NonLesionModifiers represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_NonLesionModifiers enumNonLesionModifiers)
	{
		switch(enumNonLesionModifiers)
		{
		case INTERNAL: this.strCodeValue = EnumCV_NonLesionModifiers.INTERNAL_R_40819.getValue();break;
		case EXTERNAL: this.strCodeValue = EnumCV_NonLesionModifiers.EXTERNAL_R_40941.getValue();break;
		}
	}
	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumNonLesionModifiers Object of EnumCM_NonLesionModifiers represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_NonLesionModifiers enumNonLesionModifiers)
	{
		switch(enumNonLesionModifiers)
		{
		case INTERNAL: this.strSNOMEDCTID = EnumDICOMSNOMEDMap.INTERNAL.getSNOMEDCTID();break;
		case EXTERNAL: this.strSNOMEDCTID = EnumDICOMSNOMEDMap.EXTERNAL.getSNOMEDCTID();break;
		}
	}


	/**
	 * Sets the value for NonLesionModifiers
	 * @param enumNonLesionModifiers Object of EnumCM_NonLesionModifiers.
	 */
	public void setNonLesionModifiers(EnumCM_NonLesionModifiers enumNonLesionModifiers)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumNonLesionModifiers.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumNonLesionModifiers);
		
		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumNonLesionModifiers);
	}
}
